<?php
/**
* @package    Hacks
* @subpackage WaitingMsgOnGeneratedFlux
* @author     20100
* @copyright  12/01/2011
* @version    Release: 0.2.1
*/

@session_start();
?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="fr" lang="fr">
<head>
	<title>HACK : Message d'attente pendant la gnration d'un document avec phpExcel</title>
	<meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1" />
	<link rel='stylesheet' type='text/css' href='style.css' />
	
	<!-- JQuery -->
	<script type="text/javascript" src="./lib/js/jquery/jquery-1.4.2.min.js"></script>
	<script type="text/javascript" src="./lib/js/jquery/jquery_genererFichier.js"></script>
	
	<!-- SyntaxHighlighter -->
	<script type="text/javascript" src="./lib/js/syntaxhighlighter/scripts/shCore.js"></script>
	<script type="text/javascript" src="./lib/js/syntaxhighlighter/scripts/shBrushJScript.js"></script>
	<script type="text/javascript" src="./lib/js/syntaxhighlighter/scripts/shBrushXml.js"></script>
	<script type="text/javascript" src="./lib/js/syntaxhighlighter/scripts/shBrushCss.js"></script>
	<script type="text/javascript" src="./lib/js/syntaxhighlighter/scripts/shBrushPhp.js"></script>
	<link type="text/css" rel="stylesheet" href="./lib/js/syntaxhighlighter/styles/shCoreDefault.css"/>
	
</head>
<body>

<div id='header'>
	<h1>Message d'attente pendant la gnration d'un flux de donnes (Excel, PDF, ...)</h1>	
</div>

<div id='corps'>

<h2>1 - Introduction</h2>
<h3>1.1 - Motivations</h3>	
<p>Il est souvent utile d'afficher un message d'attente pendant la gnration d'un document 
ct serveur afin d'informer l'utilisateur de l'tat : en cours de traitement, chec ou 
succs. On prendra l'exemple d'une gnration d'un document Excel avec la librairie phpExcel, 
mais ceci pourrait tre adapt  n'importe quel long traitement php gnrant un flux de donnes 
 envoyer au navigateur.</p>

<h3>1.2 - Prsentation de la solution</h3>
<p>Par l'envoi d'une requte Ajax, il est possible d'identifier un succs ou un chec d'une requte 
HTTP simple, mais certainement pas dans le cas d'un flux de donnes  gnrer. On sera dans l'incapacit 
d'utiliser le flux de donnes gnr dans l'attribut rponse de notre instance Ajax, au mieux au aura 
dans une string le contenu du flux de donnes sans possibilit de lui prciser le type du header dans 
le document. Ainsi la principale difficult rside dans le cas d'un flux de donnes complexe  dtecter, cot client 
donc en JavaScript, ce que l'on va appeler l'vnement onFinishTraitement, et l'astuce (simple une fois tablie) 
consiste  interroger une variable de session renseignant le statut de la progression du traitement par appel 
Ajax rcursif. On pourra mme avec ce mcanisme, mettre en place une progressbar PHP, JavaScript. Toutes les 
personnes qui se sont dj pench sur cette question d'implmenter une vritable progressbar peuvent mesurer 
cette difficult, mais l'article concerne uniquement  la prsentation de ce mcanisme onFinishTraitement.</p>

<p>Nous allons voir comment mettre en oeuvre un message d'attente pendant la gnration d'un document ct 
serveur, afin de faire patienter l'utilisateur. Ct serveur PHP, on utilise la librairie phpExcel pour 
gnrer des documents Excel, PDF. On a aussi ajouter la librairie MPDF qui gnre des fichiers PDF afin de 
rgler des problmes de no-border et d'optimiser les performances. La librairie MPDF est plus rapide et gnre 
des fichiers tailles moindre comparer  la librairie proposer dans phpExcel, il semble s'agir d'un hritage 
de la librairire TCPDF, qui est bien connu pour tre assez gourmande. Ct client en JavaScript, on va 
utiliser la librairie JQuery.</p>


<h2>2 - Demonstration</h2>
<h3>2.1 - Exemple</h3>
<p>
Ci-dessous, la dmonstration de la gestion de donnes incorpore un mcanisme de retardement pour le lancement
des requtes AJAX qui va s'incrementer dans le temps, dans le but d'conomiser le serveur pour les traitements
longs. Les traitements courts (de l'ordre de deux secondes) seront donc trait avec une ou deux requtes AJAX,
et les traitements longs ne pourront exceder un TimeOut  renseigner. Mais nous verrons  plus loin, dans les
parties qui decrivent le code.</p>

<p>
Voici la dmonstration :
</p>
	<?php
	// Verification que la librairie MPDF est install
	$librairieOK = true;
	$stringTmp = "";
	if(!file_exists(dirname(__FILE__)."/lib/php/MPDF46/mpdf.php")) {
		$librairieOK = false;
		$stringTmp .= "<li>La libriaire MPDF 4.6 n'est pas install - <a target='_blank' href='http://mpdf.bpm1.com/'>http://mpdf.bpm1.com</a></li>";
	}
	// Verification que la librairie phpExcel est install
	if(!file_exists(dirname(__FILE__)."/lib/php/phpExcel/Classes/PHPExcel.php")) {
		$librairieOK = false;
		$stringTmp .= "<li>La libriaire phpExcel 1.7.3c n'est pas install - <a target='_blank' href='http://phpexcel.codeplex.com/'>http://phpexcel.codeplex.com</a></li>";
	}
	// Verification que la librairie JQuery est install
	if(!file_exists(dirname(__FILE__)."/lib/js/jquery/jquery-1.4.2.min.js")) {
		$librairieOK = false;
		$stringTmp .= "<li>La libriaire JQuery 1.4.2 n'est pas install - <a target='_blank' href='http://www.jquery.com/'>http://www.jquery.com</a></li>";
	}
	
	if($librairieOK==false) {
		echo "<div class='erreurLibrairie'><p><b>Attention</b>, la dmonstration ne peut pas fonctionn car :</p><ul>".$stringTmp."</ul></div>";
	}
	?>

	<div class='demo'>
		<h2>Exemple : </h2>
		
		<ul id='blocLienGenerer'>
			<li><p><span class='generer' id='PDF'>Gnrer un document avec la librairie PDF par dfaut de phpExcel</span></p></li>
			<li><p><span class='generer' id='MPDF'>Gnrer un document avec la librairie MPDF</span></p></li>
			<li><p><span class='generer' id='Excel5'>Gnrer un document Excel5</span></p></li>
		</ul>
			
		<div id="loading">
			<div id='loading-image'></div>
			<div id='loading-content'></div>
		</div>
		<div id='loading-debug'></div>
		
		<iframe id="iframePhpExcel" src=""></iframe>
	</div>

<h3>2.2 - Code source  tlcharger de la dmonstration</h3>
<p>Le zip ci-dessous contient les codes sources de la dmonstration avec la gestion d'un 
rtardateur qui s'incrmente pour lancer les requte Ajax ainsi que d'un mode debug
pour contrler dans le navigateur le lancement des requtes Ajax.

<p>
<a href='waintingMsgOnGeneratedFluxPhpExcel_v0.2.1.zip'>Tlcharger les sources de cette demonstration (gestion d'un retardateur increment avec debug mode)</a>
</p>

<p>Cette dmonstration ncessite les librairies PHP phpExcel et MPDF, ainsi que la librairie 
JavaScript JQuery, qui ne sont pas forcement prsente dans le zip. 
Voici les rcommandations de version et qui ont t tests  utiliser pour faire 
fonctionner la dmonstration :</p>
<ul>	
	<li>La libriaire MPDF 4.6 - <a target='_blank' href='http://mpdf.bpm1.com/'>http://mpdf.bpm1.com</a></li>
	<li>La libriaire phpExcel 1.7.3c - <a target='_blank' href='http://phpexcel.codeplex.com/'>http://phpexcel.codeplex.com</a></li>
	<li>La libriaire JQuery 1.4.2 - <a target='_blank' href='http://www.jquery.com/'>http://www.jquery.com</a></li>
	<li>Il faut aussi une version PHP >= 5.2, induit par les prrequis de la librairie phpExcel</li>
</ul>




<h2>3 - Les lments XHTML pour l'interface</h2>
<h3>3.1 - Boutons pour gnrer les documents</h3>
<p>On propose la liste ci-dessous pour pointer vers la gnration des diffrents fichiers. On aurait 
tout aussi bien pu crire directement des liens vides. Les lments de la liste possde tous la
classe <span class='codeInLineCSS'>.generer</span> qui va nous servir de slecteur avec Jquery ainsi qu'un identifiant unique.</p>
<pre class='brush:xml;'>
&lt;ul id='blocLienGenerer'&gt;
	&lt;li&gt;&lt;p&gt;&lt;span class='generer' id='PDF'&gt;Gnrer un document avec la librairie PDF par dfaut de phpExcel&lt;/span&gt;&lt;/p&gt;&lt;/li&gt;
	&lt;li&gt;&lt;p&gt;&lt;span class='generer' id='MPDF'&gt;Gnrer un document avec la librairie MPDF&lt;/span&gt;&lt;/p&gt;&lt;/li&gt;
	&lt;li&gt;&lt;p&gt;&lt;span class='generer' id='Excel5'&gt;Gnrer un document Excel5&lt;/span&gt;&lt;/p&gt;&lt;/li&gt;
&lt;/ul&gt;	
</pre>	

<h3>3.2 - Bloc d'informations</h3>
<p>On ajoute ensuite une div <span class='codeInLineCSS'>#loading</span> qui va contenir l'image de chargement, du texte pour informer 
l'utilisateur sur l'tat du chargement et une div optionnel pour afficher les informations de debug</p>
<pre class='brush:xml;'>
&lt;div id=&quot;loading&quot;&gt;
	&lt;div id='loading-image'&gt;&lt;/div&gt;
	&lt;div id='loading-content'&gt;&lt;/div&gt;
&lt;/div&gt;
&lt;div id='loading-debug'&gt;&lt;/div&gt;
</pre>
<p>Les blocs div <span class='codeInLineCSS'>#loading</span> et <span class='codeInLineCSS'>#loading-debug</span> sont cachs en CSS par dfaut</p>
<pre class='brush:css;'>
#loading{display:none;}
#loading-debug{display:none;}
</pre>

<h3>3.3 - Conteneur du script gnrant le fichier</h3>
<p>Enfin on place une iframe vide qui servira de conteneur pour charger le fichier  gnrer.</p>
<pre class='brush:xml;'>
&lt;iframe id=&quot;iframePhpExcel&quot; src=&quot;&quot;&gt;&lt;/iframe&gt;	
</pre>

<p>L'iframe est cach en CSS par dfaut</p>
<pre class='brush:css;'>
#iframePhpExcel{visibility:hidden;position:absolute;}
</pre>



<h2>4 - Gnration du fichier avec phpExcel ct serveur</h2>
<p>Le script <span class='codeInLine'>phpExcel_generation.php</span> attend une variable pass en GET. Il s'agit
de la variable <span class='codeInLine'>idGenerer</span> qui prcise quel type de document doit tre gnr avec
la librairie phpExcel. Il peut s'agir d'un document gnr avec la librairie PDF par dfaut de phpExcel  savoir
TCPDF, il peut s'agir d'une librairie ajouter MPDF ou bien d'un fichier Excel5. La librairie MPDF est gnralement
utilis pour des raisons de performances et prendre en compte le no-border. Le document gnr utilise des donnes
alatoires crs pour remplir le document. On va voir squentiellement, tape par tape les instructions du script.</p>

<h3>4.1 - Initialisation variable de session</h3> 
<p>Le script commence par la dclaration de la variable de session <span class='codeInLine'>generationStatut</span>
qui va renseigner si la gnration du document est en cours ou fini.</p>
<pre class='brush:php;'>
@session_start();   
$_SESSION['generationStatut'] = &quot;progress&quot;;   
</pre>

<h3>4.2 - Fermeture de la session courante</h3>
<p>On ferme alors la session courrante immdiatement aprs, afin de permettre  d'autres script php
de pouvoir lire cette variable de session. La fonction <span class='codeInLine'>session_write_close</span>
termine la session courante, aprs avoir stock les donnes, autrement dit on force le stockage de la
variable de session pour qu'elle puiss tre utilis dans le script <span class='codeInLine'>generationStatus.php</span> lanc en 
AJAX retard rcursif.</p>
<pre class='brush:php;'>
session_write_close();
</pre>

<h3>4.3 - Instanciation de phpExcel</h3>
<p>On instancie l'objet phpExcel  partir duquel la librairie phpExcel va gnrer le document</p>
<pre class='brush:php;'>
include_once(dirname(__FILE__).&quot;/lib/php/phpExcel/Classes/PHPExcel.php&quot;);
$objPHPExcel = new PHPExcel();
	(instructions pour gnrer le document)
</pre>

<h3>4.4 - Instanciation du writer de phpExcel</h3>
<p>On crer le fichier en fonction du paramtre <span class='codeInLine'>idGenerer</span> pass en GET</p>
<pre class='brush:php;'>
$mode = (isset($_GET['mode'])) ? $_GET['mode'] : null;
$date = date(&quot;Y_m_d_H.i.s&quot;);
$nomFichier = &quot;test_&quot;.$date;
switch ($mode) {
	
	// Librairie PDF de phpExcel par dfaut utilis (bas sur TCPDF)
	case 'PDF':
		ini_set('memory_limit', '-1');
		$objWriter = new PHPExcel_Writer_PDF($objPHPExcel);
		$objWriter-&gt;setPreCalculateFormulas(false);
		break;
	
	// On utilise plutot MPDF pour regler les problmes de no-border et amlior les performances
	case 'MPDF':
		ini_set('memory_limit', '-1');
		$objWriter = new PHPExcel_Writer_HTML($objPHPExcel);
		$objWriter-&gt;setPreCalculateFormulas(false);
		$objWriter-&gt;setUseInlineCSS(true);
		ob_clean();
		$html = $objWriter-&gt;generateHTMLHeader();
		$html .= $objWriter-&gt;generateStyles();
		$html .= $objWriter-&gt;generateSheetData();
		$html .= $objWriter-&gt;generateHTMLFooter();
		include_once(dirname(__FILE__).&quot;/lib/php/MPDF46/mpdf.php&quot;);
		$mpdf = new mPDF();
		$mpdf-&gt;WriteHTML($html);			
		break;
	
	// Gnration du document en version Excel5
	Case 'Excel5':
		$objWriter = new PHPExcel_Writer_Excel5($objPHPExcel);
		$objWriter-&gt;setPreCalculateFormulas(false);	
		break;
	
	default:
		echo &quot;&lt;pre&gt;Le mode de gnration choisi &lt;b&gt;(.&quot;.$mode.&quot;.)&lt;/b&gt; n'existe pas.&lt;/pre&gt;&quot;;
}
</pre>

<h3>4.5 - Mise  jour de la variable de session</h3>
<p>On met  jour la variable de session pour informer que la gnration du fichier est termin.</p>
<pre class='brush:php;'>
session_start();
$_SESSION['generationStatut'] = &quot;fini&quot;;
</pre>

<h3>4.6 - Envoie du fichier gnr au navigateur</h3>
<p>On envoie le fichier au navigateur en prcisant les headers en fonction du fichier gnr.</p>
<pre class='brush:php;'>	
ob_clean();
switch ($mode) {
	case 'PDF':
		header('Content-type: application/pdf');
		header(&quot;Content-Disposition: attachment; filename=&quot;.$nomFichier.&quot;.pdf&quot;);
		header('Cache-Control: max-age=0');	
		$objWriter-&gt;save('php://output');	
		break;
	case 'MPDF':
		$mpdf-&gt;Output($nomFichier.&quot;.pdf&quot;,D);		
		break;
	Case 'Excel5':
		header('Content-type:application/vnd.ms-excel');
		header('Content-Disposition:inline;filename='.$nomFichier.'.xls');
		header(&quot;Cache-Control: no-cache, must-revalidate&quot;); // HTTP/1.1
		header(&quot;Expires: Sat, 26 Jul 1997 05:00:00 GMT&quot;); // Date dans le pass
		$objWriter-&gt;save('php://output');
		break;
}	
</pre>


<h3>4.7 - Script complet</h3>
<p>Au final le script complet est :</p>
<pre class='brush:php;'>
&lt;?php

//------------------------------------------------------------------.
// Variable de session pour informer sur le statut de la gnration |
//------------------------------------------------------------------'
@session_start();   
$_SESSION['generationStatut'] = &quot;progress&quot;;   


//----------------------------------------------------------------------------.
// Termine la session courante, aprs avoir stock les donnes, autrement dit |
// on force le stockage de la variable de session pour quelle puisse tre    |
// utilis dans le script generationStatus.php lanc en AJAX retard rcursif |
//----------------------------------------------------------------------------'
session_write_close();


//------------------------------.
// Cration de l'objet PHPExcel |
//------------------------------'
include_once(dirname(__FILE__).&quot;/lib/php/phpExcel/Classes/PHPExcel.php&quot;);
$dateGeneration = date('d/m/Y \ H:i:s');
$objPHPExcel = new PHPExcel();
	$objPHPExcel-&gt;setActiveSheetIndex(0);
	$objPHPExcel-&gt;getDefaultStyle()-&gt;getFont()-&gt;setName('Calibri');
	$objPHPExcel-&gt;getDefaultStyle()-&gt;getFont()-&gt;setSize(10); 
	$activeSheet = $objPHPExcel-&gt;getActiveSheet();
	$activeSheet-&gt;setTitle('Exemple de generation phpExcel');

	// Header document PHPExcel
	$activeSheet-&gt;setCellValue('A1',utf8_encode(&quot;Suivi des ventes et contrle&quot;));
	$activeSheet-&gt;setCellValue('B3',&quot;Pays&quot;);
	$activeSheet-&gt;setCellValue('B4',utf8_encode(&quot;Contexte&quot;));
	$activeSheet-&gt;setCellValue('B5',&quot;Dates des ventes&quot;);
	$activeSheet-&gt;setCellValue('B7',utf8_encode(&quot;Nombre de vendeur dans le pays&quot;));
	$activeSheet-&gt;setCellValue('B8',utf8_encode(&quot;Nombre d'usine dans le pays&quot;));
	$activeSheet-&gt;setCellValue('B9',utf8_encode(&quot;Nombre de publicit dans le pays&quot;));
	$activeSheet-&gt;setCellValue('B10',utf8_encode(&quot;Taux de vente&quot;));
	$activeSheet-&gt;setCellValue('B11',utf8_encode(&quot;Taux de rentabilit&quot;));
	$activeSheet-&gt;setCellValue('C3',utf8_encode(&quot;Espagne&quot;));
	$activeSheet-&gt;setCellValue('C4',utf8_encode(&quot;Vente d'quipement&quot;));
	$activeSheet-&gt;setCellValue('C5',utf8_encode(&quot;Du 01/01/2010 au 05/02/2010&quot;));
	$activeSheet-&gt;setCellValue('E7',71);
	$activeSheet-&gt;setCellValue('E8',37);
	$activeSheet-&gt;setCellValue('E9',16);
	$activeSheet-&gt;setCellValue('E10',utf8_encode(&quot;52 %&quot;));
	$activeSheet-&gt;setCellValue('E11',utf8_encode(&quot;23 %&quot;));
	$activeSheet-&gt;setCellValue('B12',utf8_encode(&quot;Document gnr le &quot;.$dateGeneration));
	$activeSheet-&gt;mergeCells('A1:G1');
	$activeSheet-&gt;mergeCells('C3:D3');
	$activeSheet-&gt;mergeCells('C4:D4');
	$activeSheet-&gt;mergeCells('C5:D5');
	$activeSheet-&gt;mergeCells('B7:D7');
	$activeSheet-&gt;mergeCells('B8:D8');
	$activeSheet-&gt;mergeCells('B9:D9');
	$activeSheet-&gt;mergeCells('B10:D10');
	$activeSheet-&gt;mergeCells('B11:D11');
	$activeSheet-&gt;mergeCells('B12:D12');
	
	// Mise en page du Header document PHPExcel
	$activeSheet-&gt;getStyle('A1:G1')-&gt;applyFromArray(
		array(
			'font' =&gt; array('bold' =&gt; true, 'size'=&gt;16),
			'alignment' =&gt; array('horizontal' =&gt; PHPExcel_Style_Alignment::HORIZONTAL_CENTER),
			'borders'=&gt;array('allborders'=&gt;array('style'=&gt;PHPExcel_Style_Border::BORDER_THIN)),
			'fill'=&gt;array('type'=&gt;PHPExcel_Style_Fill::FILL_SOLID,'color'=&gt;array('argb'=&gt;'FF99CCFF'))
		)
	);
	$activeSheet-&gt;getStyle('B12')-&gt;applyFromArray(array('font' =&gt; array('italic' =&gt; true)));
	$activeSheet-&gt;getStyle('B2:B11')-&gt;applyFromArray(array('font' =&gt; array('bold' =&gt; true)));
	$activeSheet-&gt;getStyle('B3:D5')-&gt;applyFromArray(
		array('borders'=&gt;array('allborders'=&gt;array('style'=&gt;PHPExcel_Style_Border::BORDER_THIN)))
	);
	$activeSheet-&gt;getStyle('B7:E11')-&gt;applyFromArray(
		array('borders'=&gt;array('allborders'=&gt;array('style'=&gt;PHPExcel_Style_Border::BORDER_THIN)))
	);
	$activeSheet-&gt;getStyle('E7:E11')-&gt;applyFromArray(
		array('alignment' =&gt; array('horizontal' =&gt; PHPExcel_Style_Alignment::HORIZONTAL_CENTER))
	);
	
	// Body document PHPExcel
	$activeSheet-&gt;setCellValueByColumnAndRow(0, 14, &quot;Ident&quot;);
	$activeSheet-&gt;setCellValueByColumnAndRow(1, 14, &quot;Nom&quot;);
	$activeSheet-&gt;setCellValueByColumnAndRow(2, 14, &quot;Secteur&quot;);
	$activeSheet-&gt;setCellValueByColumnAndRow(3, 14, &quot;Nature&quot;);
	$activeSheet-&gt;setCellValueByColumnAndRow(4, 14, &quot;Ref&quot;);
	$activeSheet-&gt;setCellValueByColumnAndRow(5, 14, &quot;Date\n&quot;.utf8_encode(&quot;Rponse&quot;));
	$activeSheet-&gt;setCellValueByColumnAndRow(6, 14, &quot;Controle\n&quot;.utf8_encode(&quot;des produits&quot;));
	$activeSheet-&gt;getStyle('A14:G14')-&gt;applyFromArray(
		array(
			'font' =&gt; array('bold' =&gt; true),
			'alignment' =&gt; array('horizontal' =&gt; PHPExcel_Style_Alignment::HORIZONTAL_CENTER),
			'borders'=&gt;array('allborders'=&gt;array('style'=&gt;PHPExcel_Style_Border::BORDER_THIN)),
			'fill'=&gt;array('type'=&gt;PHPExcel_Style_Fill::FILL_SOLID,'color'=&gt;array('argb'=&gt;'FF99CCFF'))
		)
	);
	$activeSheet-&gt;getStyle('F14')-&gt;getAlignment()-&gt;setWrapText(true);
	$activeSheet-&gt;getStyle('G14')-&gt;getAlignment()-&gt;setWrapText(true);
	$activeSheet-&gt;getStyle('A14:G14')-&gt;getAlignment()-&gt;setVertical(PHPExcel_Style_Alignment::VERTICAL_TOP);
	$arrayNatureLibelle = array('Agroalimentaire', 'Usine', 'Universit');
	$arrayNatureCode = array(151,152,153,168,198,286,292,336,541,542,543,556);
	$ligne = 15;
	for($i=0;$i&lt;71;$i++) {
		$rneEcole = &quot;XID&quot;.($i+10);
		$nom = &quot;VENTE &quot;.$i;
		$secteur = (rand(0,1)==0) ? 'GLOBAL' : 'ATOME';
		$natureLibelle = $arrayNatureLibelle[array_rand($arrayNatureLibelle,1)];
		$natureCode = $arrayNatureCode[array_rand($arrayNatureCode,1)];
		$dateReponse = date(&quot;d/m/Y&quot;,strtotime(&quot;2010-01-01 + &quot;
			.rand(0,round((strtotime('2010-02-05')-strtotime('2010-01-01'))/(60*60*24))).&quot; days&quot;));
		$campagneValiderEcole = (rand(0,1)==0) ? 'OUI' : 'NON';
		$activeSheet-&gt;setCellValueByColumnAndRow(0, $ligne, utf8_encode($rneEcole));
		$activeSheet-&gt;setCellValueByColumnAndRow(1, $ligne, utf8_encode($nom));
		$activeSheet-&gt;setCellValueByColumnAndRow(2, $ligne, utf8_encode($secteur));
		$activeSheet-&gt;setCellValueByColumnAndRow(3, $ligne, utf8_encode($natureLibelle));
		$activeSheet-&gt;setCellValueByColumnAndRow(4, $ligne, utf8_encode($natureCode));
		$activeSheet-&gt;setCellValueByColumnAndRow(5, $ligne, utf8_encode($dateReponse));
		$activeSheet-&gt;setCellValueByColumnAndRow(6, $ligne, utf8_encode($campagneValiderEcole));
		if(strcmp($campagneValiderEcole,'OUI')==0) {
			$activeSheet-&gt;getStyle('A'.$ligne.':G'.$ligne)-&gt;applyFromArray(
				array('fill'=&gt;array('type'=&gt;PHPExcel_Style_Fill::FILL_SOLID,'color'=&gt;array('argb'=&gt;'FFCCFFCC')))
			);
		}
		$ligne++;
	}
	$activeSheet-&gt;getStyle('A15:G'.($ligne-1))-&gt;applyFromArray(
		array(
			'borders'=&gt;array(
				'left'=&gt;array('style'=&gt;PHPExcel_Style_Border::BORDER_THIN  ),
				'right'=&gt;array('style'=&gt;PHPExcel_Style_Border::BORDER_THIN  ),
				'bottom'=&gt;array('style'=&gt;PHPExcel_Style_Border::BORDER_THIN  ),
				'vertical'=&gt;array('style'=&gt;PHPExcel_Style_Border::BORDER_THIN  ),
				'horizontal'=&gt;array('style'=&gt;PHPExcel_Style_Border::BORDER_THIN  )
			)		
		)
	);
	$styleColonneCentrer = array('alignment' =&gt; array('horizontal' =&gt; PHPExcel_Style_Alignment::HORIZONTAL_CENTER));
	$activeSheet-&gt;getStyle('C15:C'.($ligne-1))-&gt;applyFromArray($styleColonneCentrer);
	$activeSheet-&gt;getStyle('E15:G'.($ligne-1))-&gt;applyFromArray($styleColonneCentrer);
	$activeSheet-&gt;getColumnDimension('A')-&gt;setWidth(12);
	$activeSheet-&gt;getColumnDimension('B')-&gt;setWidth(40);
	$activeSheet-&gt;getColumnDimension('C')-&gt;setWidth(12);
	$activeSheet-&gt;getColumnDimension('D')-&gt;setWidth(40);
	$activeSheet-&gt;getColumnDimension('E')-&gt;setWidth(6);
	$activeSheet-&gt;getColumnDimension('F')-&gt;setWidth(12);
	$activeSheet-&gt;getColumnDimension('G')-&gt;setWidth(22);

	// Set Zone d'impression
	$activeSheet-&gt;getPageSetup()-&gt;setPrintArea('A1:G'.($ligne));
	$activeSheet-&gt;getPageSetup()-&gt;setOrientation(PHPExcel_Worksheet_PageSetup::ORIENTATION_LANDSCAPE);
	$activeSheet-&gt;getPageSetup()-&gt;setPaperSize(PHPExcel_Worksheet_PageSetup::PAPERSIZE_A4);
	$activeSheet-&gt;getPageMargins()-&gt;SetLeft(0.1);
	$activeSheet-&gt;getPageMargins()-&gt;SetRight(0.1);
	$activeSheet-&gt;getPageMargins()-&gt;setTop(0.4);
	$activeSheet-&gt;getPageMargins()-&gt;setBottom(0.6);
	$activeSheet-&gt;getPageMargins()-&gt;setHeader(0.1);
	$activeSheet-&gt;getPageMargins()-&gt;setFooter(0.4);
	$activeSheet-&gt;getHeaderFooter()-&gt;setOddHeader(&quot;&amp;C&amp;HAPPLICATION v.0.1&quot;);
	$activeSheet-&gt;getHeaderFooter()-&gt;setOddFooter('&amp;L&amp;BGeneration flux de donnees&amp;RPage &amp;P / &amp;N');
	$activeSheet-&gt;getPageSetup()-&gt;setHorizontalCentered(true);
	$activeSheet-&gt;getPageSetup()-&gt;setVerticalCentered(false);
	$activeSheet-&gt;getPageSetup()-&gt;setRowsToRepeatAtTopByStartAndEnd(14, 14);


//-----------------------------------------------------.
// Cration du writer en fonction du moge pass en GET |
//-----------------------------------------------------'
$date = date(&quot;Y_m_d_H.i.s&quot;);
$mode = (isset($_GET['mode'])) ? $_GET['mode'] : null;
$nomFichier = &quot;test_&quot;.$date;
switch ($mode) {
	// Librairie PDF de phpExcel par dfaut utilis (bas sur TCPDF)
	case 'PDF':
		ini_set('memory_limit', '-1');
		$objWriter = new PHPExcel_Writer_PDF($objPHPExcel);
		$objWriter-&gt;setPreCalculateFormulas(false);
		break;
	// On utilise plutot MPDF pour regler les problmes de no-border et amlior les performances
	case 'MPDF':
		ini_set('memory_limit', '-1');
		$objWriter = new PHPExcel_Writer_HTML($objPHPExcel);
		$objWriter-&gt;setPreCalculateFormulas(false);
		$objWriter-&gt;setUseInlineCSS(true);
		ob_clean();
		$html = $objWriter-&gt;generateHTMLHeader();
		$html .= $objWriter-&gt;generateStyles();
		$html .= $objWriter-&gt;generateSheetData();
		$html .= $objWriter-&gt;generateHTMLFooter();
		include_once(dirname(__FILE__).&quot;/lib/php/MPDF46/mpdf.php&quot;);
		$mpdf = new mPDF();
		$mpdf-&gt;SetHeader(
			array (
				'L' =&gt; array(
					'content' =&gt; '',
					'font-size' =&gt; 10,'font-style' =&gt; 'B','font-family' =&gt; 'FreeSerif','color'=&gt;'#000000'),
				'C' =&gt; array(
					'content' =&gt; ' Exemple',
					'font-size' =&gt; 9,'font-style' =&gt; 'B','font-family' =&gt; 'FreeSerif','color'=&gt;'#000000'),
				'R' =&gt; array(
					'content' =&gt; '',
					'font-size' =&gt; 10,'font-style' =&gt; 'B','font-family' =&gt; 'FreeSerif','color'=&gt;'#000000'),
				'line' =&gt; 1
			), 
			'O'
		);
		$mpdf-&gt;SetFooter(
			array (
				'L' =&gt; array(
					'content' =&gt; 
					'Suivi de validation des directeurs',
					'font-size' =&gt; 9,'font-style' =&gt; '','font-family' =&gt; 'FreeSerif','color'=&gt;'#000000'),
				'C' =&gt; array(
					'content' =&gt; '',
					'font-size' =&gt; 9,'font-style' =&gt; 'B','font-family' =&gt; 'FreeSerif','color'=&gt;'#000000'),
				'R' =&gt; array(
					'content' =&gt; 'Page {PAGENO} / {nbpg}',
					'font-size' =&gt; 9,'font-style' =&gt; '','font-family' =&gt; 'FreeSerif','color'=&gt;'#000000'),
				'line' =&gt; 1
			), 
			'O'
		);
		$mpdf-&gt;WriteHTML($html);			
		break;
	// Gnration du document en version Excel5
	Case 'Excel5':
		$objWriter = new PHPExcel_Writer_Excel5($objPHPExcel);
		$objWriter-&gt;setPreCalculateFormulas(false);	
		break;
	default:
		echo &quot;&lt;pre&gt;Le mode de gnration choisi &lt;b&gt;(.&quot;.$mode.&quot;.)&lt;/b&gt; n'existe pas.&lt;/pre&gt;&quot;;
}

	
//-----------------------------------------------.
// Informe que la gnration du fichier est fini |
//-----------------------------------------------'
session_start();
$_SESSION['generationStatut'] = &quot;fini&quot;;


//--------------------------------------------------.
// Envoi le fichier au browser selon le mode choisi |
//--------------------------------------------------'	
ob_clean();
switch ($mode) {
	case 'PDF':
		header('Content-type: application/pdf');
		header(&quot;Content-Disposition: attachment; filename=&quot;.$nomFichier.&quot;.pdf&quot;);
		header('Cache-Control: max-age=0');	
		$objWriter-&gt;save('php://output');	
		break;
	case 'MPDF':
		$mpdf-&gt;Output($nomFichier.&quot;.pdf&quot;,D);		
		break;
	Case 'Excel5':
		header('Content-type:application/vnd.ms-excel');
		header('Content-Disposition:inline;filename='.$nomFichier.'.xls');
		header(&quot;Cache-Control: no-cache, must-revalidate&quot;); // HTTP/1.1
		header(&quot;Expires: Sat, 26 Jul 1997 05:00:00 GMT&quot;); // Date dans le pass
		$objWriter-&gt;save('php://output');
		break;
}	
	
?&gt;	
</pre>




<h2>5 - Lecture de la variable de session cte serveur php</h2>

<p>Le script <span class='codeInLine'>generationStatus.php</span> est tout simple, il sagit simplement de 
faire un echo de la variable de session qui renseigne sur lavance du traitement. Ce script sera par la
suite appell en JavaScript afin d'atteindre l'venement onFinishTraitement.</p>
<pre class='brush:php;'>
&lt;?php  
	session_start();
	echo $_SESSION['generationStatut'];
?&gt;
</pre>


<h2>6 - Lecture de la variable de session par appel AJAX retard recursif</h2>

<h3>6.1 - Chargeur JQuery</h3>
<p>On utilise la librairie JQuery pour nous simplifier la vie et avec JQuery on commence toujours par attendre que l'arbre DOM 
soit entirement charg avec l'appel de l'instruction <span class='codeInLine'>$(document).ready(function(){...});</span>.</p>

<p>On utlise ensuite le slecteur sur la classe <span class='codeInLineCSS'>.generer</span> avec <span class='codeInLine'>$('.generer')</span>, et pour chaque 
lment selectionn on ajoute un listeneur sur l'venement clik.</p>
<pre class='brush:js;'>
$(document).ready(function(){
	$('.generer').each(function() {
		$(this).click(
			function(){
				(...)
			}
		);
	});
});
</pre>


<h3>6.2 - Mise en oeuvre du listener onClick sur les boutons de l'interface</h3>
<p>En JavaScript sur lvnement de clic pour lancer la gnration du fichier : </p>
<ul>
	<li>La premire instruction est de rcupre l'identifiant de l'lment cliqu. Dans notre exemple, il s'agira de PDF, MPDF ou Excel5.</li>
	<li>On informe l'utilisateur que la gnration du fichier est en cours en affichant une image et du texte. Le chargement de l'image
	dans <span class='codeInLineCSS'>#loading-image</span> se fait simplement par l'ajout de la classe <span class='codeInLineCSS'>.chargement</span></li>
	<li>On charge dans liframe le script php <span class='codeInLine'>phpExcel_generation.php?mode=idGenerer</span> qui gnre le document PDF, MPDF ou Excel5</li>
	<li>On fait un appel retard en utilisant <span class='codeInLine'>setTimeout</span> de la fonction <span class='codeInLine'>getGenerationStatus</span>. 
	On remarque que pour pouvoir appell une fonction avec des paramtres dans <span class='codeInLine'>setTimeout</span>, il est ncessaire d'utiliser une fonction anonyme.</li>
</ul>
<pre class='brush:js;'>
$(document).ready(function(){
 
	$('.generer').each(function() {
		$(this).click(
			function(){				
				// Rcupration de l'identifiant du fichier  gnrer surlequel l'utilisateur  cliquer
				var idGenerer = $(this).attr('id');
				
				// Informe l'utilisateur que la gnration du fichier est en cours
				var stringTemp = "<p>Gnration du fichier "+idGenerer+" en cours...<p/>";
				$("#loading-content").html(stringTemp);
				$("#loading-image").removeClass("information");
				$("#loading-image").addClass("chargement");
				$("#loading").css("display","block");
				$("#loading-debug").html("");
				$("#loading-debug").css("display","none");

				// Chargement de l'iframe associ  l'idGenerer click
				var oIFrm = document.getElementById("iframePhpExcel");
				oIFrm.contentWindow.document.location = "phpExcel_generation.php?mode="+idGenerer;
				
				// Appel de la fonction rcursive pour tester le statut aprs une attente d'une seconde.
				var timeWait = 1000;
				var timeFactor = 2;
				var timeWaitMax = 8000;
				var timeOut = 30000;
				var timeExec = 1000;
				var nbAppel = 0;					
				setTimeout(
					function() { 
						getGenerationStatus(timeWait, timeFactor, timeWaitMax, timeOut, timeExec, nbAppel, idGenerer, true); 
					}
					, timeWait
				);
			}
		);
	});

});
</pre>


<h3>6.3 - Appel AJAX rcursif retard</h3>
<p>La fonction <span class='codeInLine'>getGenerationStatus</span> effectue un appel AJAX rcursif retard. 
L'appel AJAX se fait de manire asynchrone sur la page <span class='codeInLine'>phpExcel_generationStatus.php</span>
et cette fonction prend en compte plusieurs paramtres :</p>
<ul>
	<li>param (int) <span class='codeInLine'>timeWait</span> : Temps en ms d'attente avant de relancer une requte AJAX</li>
	<li>param (int) <span class='codeInLine'>timeFactor</span> : Facteur pour incrmenter le temps avant le lancement rcursif</li>
	<li>param (int) <span class='codeInLine'>timeWaitMax</span> : Temps en ms d'attente maximum avant de relancer une requte AJAX</li>
	<li>param (int) <span class='codeInLine'>timeOut</span> : Temps en ms d'attente global maximum</li>
	<li>param (int) <span class='codeInLine'>timeExec</span> : Temps d'execution</li>
	<li>param (int) <span class='codeInLine'>nbAppel</span> : Nombre d'appel rcursif effectu</li>
	<li>param (String) <span class='codeInLine'>idGenerer</span> : Type de fichier generer (PDF, MPDF, Excel5)</li>
	<li>param (Bool) <span class='codeInLine'>debug</span> : True affiche le debug</li>
</ul>

<p>Avec cette fonction on repond  la question suivante : est-ce que la gnration du document est termin ?</p>
<p>Tant que la rponse
est ngative, le fichier est en cours de gnration et la relance de cette question ne se fait qu'a intervalle de temps
<span class='codeInLine'>timeWait</span> qui s'incremente  chaque appel  l'aide 
d'un facteur <span class='codeInLine'>timeFactor</span>. Ainsi on interroge frquement le serveur au dbut de la gnration, et 
le temps d'attente s'agrandit d'appel en appel avant d'atteindre un temps maximum d'attente <span class='codeInLine'>timeWaitMax</span>. 
Si le nombre d'appel est trop important, un arret est prevu  l'aide d'un temps d'execution maximum <span class='codeInLine'>timeOut</span>. 
Il est aussi possible d'afficher des informations sur les appels effectus 
si le paramtre <span class='codeInLine'>debug</span> vaut <span class='codeInLine'>true</span>.
</p>
<pre class='brush:js;'>
 /**
 * param (int) timeWait : Temps en ms d'attente avant de relancer une requte AJAX
 * param (int) timeFactor : Facteur pour incrmenter le temps avant le lancement rcursif
 * param (int) timeWaitMax : Temps en ms d'attente maximum avant de relancer une requte AJAX
 * param (int) timeOut : Temps en ms d'attente global maximum
 * param (int) timeExec : Temps d'execution
 * param (int) nbAppel : Nombre d'appel rcursif effectu
 * param (String) idGenerer : Type de fichier generer (PDF, MPDF, Excel5)
 * param (Bool) debug : True affiche le debug
 */
function getGenerationStatus(timeWait, timeFactor, timeWaitMax, timeOut, timeExec, nbAppel, idGenerer, debug) {		
	
	nbAppel = nbAppel+1;
	timeExec = timeExec+timeWait;
	var timeWaitCurrent = timeWait*timeFactor;
	if(timeWaitCurrent&gt;timeWaitMax) {
		timeWaitCurrent = timeWaitMax;
	}
	
	if(timeExec&lt;timeOut) {
		$.ajax({
			url: &quot;phpExcel_generationStatus.php&quot;,
			type: &quot;POST&quot;,
			success: function(data) {
				if(data==&quot;progress&quot;) {
					var stringTemp = &quot;&lt;p&gt;Gnration du fichier &quot;+idGenerer+&quot; en cours...&lt;p/&gt;&quot;;
					$(&quot;#loading-content&quot;).html(stringTemp);
					if(debug) {
						var stringTempDebug = 
						&quot;&lt;p class='monospace'&gt;&quot;+
							&quot;--&gt; Numro d'appel = &quot;+nbAppel+
							&quot;&lt;br/&gt; --&gt; Temps d'attente avant le prochain appel = &quot;+timeWaitCurrent/1000+&quot; sec&quot;+
							&quot;&lt;br/&gt; --&gt; Temps d'execution total = &quot;+timeExec/1000+&quot; sec&quot;+
						&quot;&lt;/p&gt;&lt;p class='monospace'&gt;Return statut : progress&lt;/p&gt;&quot;;
						$(&quot;#loading-debug&quot;).append(stringTempDebug);
						$(&quot;#loading-debug&quot;).css(&quot;display&quot;,&quot;block&quot;);
					}
					setTimeout(
						function() { 
							getGenerationStatus(
								timeWaitCurrent, timeFactor, timeWaitMax, timeOut, timeExec, nbAppel, idGenerer, true); 
							}
						, timeWaitCurrent
					);
				} else {
					if(debug) {
						var stringTempDebug = 
						&quot;&lt;p class='monospace'&gt;&quot;+
							&quot;--&gt; Numro d'appel = &quot;+nbAppel+
							&quot;&lt;br/&gt; --&gt; Temps d'execution total = &quot;+timeExec/1000+&quot; sec&quot;+
						&quot;&lt;/p&gt;&lt;p class='monospace'&gt;Return statut : fini&lt;/p&gt;&quot;;
						$(&quot;#loading-debug&quot;).append(stringTempDebug);
						$(&quot;#loading-debug&quot;).css(&quot;display&quot;,&quot;block&quot;);
					}
					var stringTemp = &quot;&lt;p&gt;Gnration du fichier &quot;+idGenerer+&quot; termin&lt;p/&gt;&quot;;
					$(&quot;#loading-content&quot;).html(stringTemp);
					$('#loading-image').addClass('information');
					//$(&quot;#loading&quot;).delay(3000).fadeOut(&quot;slow&quot;);
				}
			}
		});
	} else {
		if(debug) {
			var stringTempDebug = 
			&quot;&lt;p class='monospace'&gt;&quot;+
				&quot;--&gt; Numro d'appel = &quot;+nbAppel+
				&quot;&lt;br/&gt; --&gt; Temps d'execution total = &quot;+timeExec/1000+&quot; sec&quot;+
			&quot;&lt;/p&gt;&lt;p class='monospace'&gt;TimeOut atteint&lt;/p&gt;&quot;;
			$(&quot;#loading-debug&quot;).append(stringTempDebug);
			$(&quot;#loading-debug&quot;).css(&quot;display&quot;,&quot;block&quot;);
		}
		var stringTemp = &quot;&lt;p&gt;TimeOut atteint.&lt;p/&gt;&quot;;
		$(&quot;#loading-content&quot;).html(stringTemp);
		$('#loading-image').addClass('information');
	}
}
</pre>

















</div>

<div id="footer">
	<img id='logo20100' src='./images/logo20100.png' alt="Logo 20100"/>
	<p>v0.2 &copy; 20100 Documentation <br/> Janvier 2011 <br/>20100.heyhey@gmail.com</p>	
</div>

<script type="text/javascript">
	SyntaxHighlighter.defaults['gutter'] = false;
	SyntaxHighlighter.defaults['smart-tabs'] = false;
	SyntaxHighlighter.defaults['toolbar'] = false;	
	SyntaxHighlighter.all();
</script>
</body>
</html>